diff --git a/boot/menhir/parser.ml b/boot/menhir/parser.ml
index 6b6fc22..dce95f7 100644
--- a/boot/menhir/parser.ml
+++ b/boot/menhir/parser.ml
@@ -45762,9 +45832,9 @@ module Tables = struct
         let _6 : unit = Obj.magic _6 in
         let _5 : (Parsetree.core_type option * Parsetree.core_type option) = Obj.magic _5 in
         let _1_inlined1 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 45768 "parsing/parser.ml"
+# 45838 "parsing/parser.ml"
         ) = Obj.magic _1_inlined1 in
         let _3 : (Asttypes.mutable_flag) = Obj.magic _3 in
         let _1 : (Parsetree.attributes) = Obj.magic _1 in
@@ -45776,30 +45846,30 @@ module Tables = struct
   Parsetree.attributes) = let _4 =
           let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
           let _1 = 
-# 3409 "parsing/parser.mly"
+# 3429 "parsing/parser.mly"
                                                 ( _1 )
-# 45782 "parsing/parser.ml"
+# 45852 "parsing/parser.ml"
            in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 45790 "parsing/parser.ml"
+# 45860 "parsing/parser.ml"
           
         in
         let _startpos__4_ = _startpos__1_inlined1_ in
         let _2 = 
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 45797 "parsing/parser.ml"
+# 45867 "parsing/parser.ml"
          in
         let (_endpos__2_, _startpos__2_) = (_endpos__1_, _startpos__1_) in
         let _1 = 
-# 3649 "parsing/parser.mly"
+# 3677 "parsing/parser.mly"
                                                 ( Fresh )
-# 45803 "parsing/parser.ml"
+# 45873 "parsing/parser.ml"
          in
         let (_endpos__1_, _startpos__1_) = (_endpos__0_, _endpos__0_) in
         let _endpos = _endpos__7_ in
@@ -45815,11 +45885,11 @@ module Tables = struct
               _startpos__4_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1866 "parsing/parser.mly"
+# 1874 "parsing/parser.mly"
       ( let e = mkexp_constraint ~loc:_sloc _7 _5 in
         (_4, _3, Cfk_concrete (_1, e)), _2
       )
-# 45823 "parsing/parser.ml"
+# 45893 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -45877,9 +45947,9 @@ module Tables = struct
         let _6 : unit = Obj.magic _6 in
         let _5 : (Parsetree.core_type option * Parsetree.core_type option) = Obj.magic _5 in
         let _1_inlined2 : (
-# 651 "parsing/parser.mly"
+# 659 "parsing/parser.mly"
        (string)
-# 45883 "parsing/parser.ml"
+# 45953 "parsing/parser.ml"
         ) = Obj.magic _1_inlined2 in
         let _3 : (Asttypes.mutable_flag) = Obj.magic _3 in
         let _1_inlined1 : (Parsetree.attributes) = Obj.magic _1_inlined1 in
@@ -45892,33 +45962,33 @@ module Tables = struct
   Parsetree.attributes) = let _4 =
           let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined2_, _startpos__1_inlined2_, _1_inlined2) in
           let _1 = 
-# 3409 "parsing/parser.mly"
+# 3429 "parsing/parser.mly"
                                                 ( _1 )
-# 45898 "parsing/parser.ml"
+# 45968 "parsing/parser.ml"
            in
           let _endpos = _endpos__1_ in
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 45906 "parsing/parser.ml"
+# 45976 "parsing/parser.ml"
           
         in
         let _startpos__4_ = _startpos__1_inlined2_ in
         let _2 =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 45915 "parsing/parser.ml"
+# 45985 "parsing/parser.ml"
           
         in
         let (_endpos__2_, _startpos__2_) = (_endpos__1_inlined1_, _startpos__1_inlined1_) in
         let _1 = 
-# 3650 "parsing/parser.mly"
+# 3678 "parsing/parser.mly"
                                                 ( Override )
-# 45922 "parsing/parser.ml"
+# 45992 "parsing/parser.ml"
          in
         let _endpos = _endpos__7_ in
         let _symbolstartpos = if _startpos__1_ != _endpos__1_ then
@@ -45933,11 +46003,11 @@ module Tables = struct
               _startpos__4_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1866 "parsing/parser.mly"
+# 1874 "parsing/parser.mly"
       ( let e = mkexp_constraint ~loc:_sloc _7 _5 in
         (_4, _3, Cfk_concrete (_1, e)), _2
       )
-# 45941 "parsing/parser.ml"
+# 46011 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46004,9 +46074,9 @@ module Tables = struct
         let _v : (Parsetree.value_description * string Asttypes.loc option) = let attrs2 =
           let _1 = _1_inlined3 in
           
-# 3743 "parsing/parser.mly"
+# 3771 "parsing/parser.mly"
     ( _1 )
-# 46010 "parsing/parser.ml"
+# 46080 "parsing/parser.ml"
           
         in
         let _endpos_attrs2_ = _endpos__1_inlined3_ in
@@ -46016,30 +46086,30 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46022 "parsing/parser.ml"
+# 46092 "parsing/parser.ml"
           
         in
         let attrs1 =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 46030 "parsing/parser.ml"
+# 46100 "parsing/parser.ml"
           
         in
         let _endpos = _endpos_attrs2_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 2792 "parsing/parser.mly"
+# 2812 "parsing/parser.mly"
     ( let attrs = attrs1 @ attrs2 in
       let loc = make_loc _sloc in
       let docs = symbol_docs _sloc in
       Val.mk id ty ~attrs ~loc ~docs,
       ext )
-# 46043 "parsing/parser.ml"
+# 46113 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46055,9 +46125,9 @@ module Tables = struct
         let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _endpos = _startpos in
         let _v : (Asttypes.virtual_flag) = 
-# 3610 "parsing/parser.mly"
+# 3638 "parsing/parser.mly"
                                                 ( Concrete )
-# 46061 "parsing/parser.ml"
+# 46131 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46080,9 +46150,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.virtual_flag) = 
-# 3611 "parsing/parser.mly"
+# 3639 "parsing/parser.mly"
                                                 ( Virtual )
-# 46086 "parsing/parser.ml"
+# 46156 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46105,9 +46175,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.mutable_flag) = 
-# 3634 "parsing/parser.mly"
+# 3662 "parsing/parser.mly"
             ( Immutable )
-# 46111 "parsing/parser.ml"
+# 46181 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46137,9 +46207,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__2_ in
         let _v : (Asttypes.mutable_flag) = 
-# 3635 "parsing/parser.mly"
+# 3663 "parsing/parser.mly"
                     ( Mutable )
-# 46143 "parsing/parser.ml"
+# 46213 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46169,9 +46239,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__2_ in
         let _v : (Asttypes.mutable_flag) = 
-# 3636 "parsing/parser.mly"
+# 3664 "parsing/parser.mly"
                     ( Mutable )
-# 46175 "parsing/parser.ml"
+# 46245 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46194,9 +46264,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.private_flag) = 
-# 3641 "parsing/parser.mly"
+# 3669 "parsing/parser.mly"
             ( Public )
-# 46200 "parsing/parser.ml"
+# 46270 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46226,9 +46296,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__2_ in
         let _v : (Asttypes.private_flag) = 
-# 3642 "parsing/parser.mly"
+# 3670 "parsing/parser.mly"
                     ( Private )
-# 46232 "parsing/parser.ml"
+# 46302 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46258,9 +46328,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__2_ in
         let _v : (Asttypes.private_flag) = 
-# 3643 "parsing/parser.mly"
+# 3671 "parsing/parser.mly"
                     ( Private )
-# 46264 "parsing/parser.ml"
+# 46334 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46322,27 +46392,27 @@ module Tables = struct
             let xs = 
 # 253 "<standard.mly>"
     ( List.rev xs )
-# 46326 "parsing/parser.ml"
+# 46396 "parsing/parser.ml"
              in
             
-# 901 "parsing/parser.mly"
+# 909 "parsing/parser.mly"
     ( xs )
-# 46331 "parsing/parser.ml"
+# 46401 "parsing/parser.ml"
             
           in
           
-# 2892 "parsing/parser.mly"
+# 2912 "parsing/parser.mly"
     ( _1 )
-# 46337 "parsing/parser.ml"
+# 46407 "parsing/parser.ml"
           
         in
         let _endpos__6_ = _endpos_xs_ in
         let _5 =
           let _1 = _1_inlined2 in
           
-# 3205 "parsing/parser.mly"
+# 3225 "parsing/parser.mly"
     ( _1 )
-# 46346 "parsing/parser.ml"
+# 46416 "parsing/parser.ml"
           
         in
         let _3 =
@@ -46351,16 +46421,16 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46357 "parsing/parser.ml"
+# 46427 "parsing/parser.ml"
           
         in
         let _endpos = _endpos__6_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 3128 "parsing/parser.mly"
+# 3148 "parsing/parser.mly"
       ( let lident = loc_last _3 in
         Pwith_type
           (_3,
@@ -46370,7 +46440,7 @@ module Tables = struct
               ~manifest:_5
               ~priv:_4
               ~loc:(make_loc _sloc))) )
-# 46374 "parsing/parser.ml"
+# 46444 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46423,9 +46493,9 @@ module Tables = struct
         let _v : (Parsetree.with_constraint) = let _5 =
           let _1 = _1_inlined2 in
           
-# 3205 "parsing/parser.mly"
+# 3225 "parsing/parser.mly"
     ( _1 )
-# 46429 "parsing/parser.ml"
+# 46499 "parsing/parser.ml"
           
         in
         let _endpos__5_ = _endpos__1_inlined2_ in
@@ -46435,16 +46505,16 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46441 "parsing/parser.ml"
+# 46511 "parsing/parser.ml"
           
         in
         let _endpos = _endpos__5_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 3141 "parsing/parser.mly"
+# 3161 "parsing/parser.mly"
       ( let lident = loc_last _3 in
         Pwith_typesubst
          (_3,
@@ -46452,7 +46522,7 @@ module Tables = struct
               ~params:_2
               ~manifest:_5
               ~loc:(make_loc _sloc))) )
-# 46456 "parsing/parser.ml"
+# 46526 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46501,9 +46571,9 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46507 "parsing/parser.ml"
+# 46577 "parsing/parser.ml"
           
         in
         let _2 =
@@ -46512,15 +46582,15 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46518 "parsing/parser.ml"
+# 46588 "parsing/parser.ml"
           
         in
         
-# 3149 "parsing/parser.mly"
+# 3169 "parsing/parser.mly"
       ( Pwith_module (_2, _4) )
-# 46524 "parsing/parser.ml"
+# 46594 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46569,9 +46639,9 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46575 "parsing/parser.ml"
+# 46645 "parsing/parser.ml"
           
         in
         let _2 =
@@ -46580,15 +46650,15 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 46586 "parsing/parser.ml"
+# 46656 "parsing/parser.ml"
           
         in
         
-# 3151 "parsing/parser.mly"
+# 3171 "parsing/parser.mly"
       ( Pwith_modsubst (_2, _4) )
-# 46592 "parsing/parser.ml"
+# 46662 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46611,9 +46681,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.private_flag) = 
-# 3154 "parsing/parser.mly"
+# 3174 "parsing/parser.mly"
                    ( Public )
-# 46617 "parsing/parser.ml"
+# 46687 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46643,9 +46713,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__2_ in
         let _v : (Asttypes.private_flag) = 
-# 3155 "parsing/parser.mly"
+# 3175 "parsing/parser.mly"
                    ( Private )
-# 46649 "parsing/parser.ml"
+# 46719 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -46674,105 +46744,105 @@ end
 let use_file =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1809 lexer lexbuf) : (
-# 787 "parsing/parser.mly"
+# 795 "parsing/parser.mly"
       (Parsetree.toplevel_phrase list)
-# 46680 "parsing/parser.ml"
+# 46750 "parsing/parser.ml"
     ))
 
 and toplevel_phrase =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1789 lexer lexbuf) : (
-# 785 "parsing/parser.mly"
+# 793 "parsing/parser.mly"
       (Parsetree.toplevel_phrase)
-# 46688 "parsing/parser.ml"
+# 46758 "parsing/parser.ml"
     ))
 
 and parse_val_longident =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1783 lexer lexbuf) : (
-# 797 "parsing/parser.mly"
+# 805 "parsing/parser.mly"
       (Longident.t)
-# 46696 "parsing/parser.ml"
+# 46766 "parsing/parser.ml"
     ))
 
 and parse_pattern =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1779 lexer lexbuf) : (
-# 793 "parsing/parser.mly"
+# 801 "parsing/parser.mly"
       (Parsetree.pattern)
-# 46704 "parsing/parser.ml"
+# 46774 "parsing/parser.ml"
     ))
 
 and parse_mty_longident =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1775 lexer lexbuf) : (
-# 799 "parsing/parser.mly"
+# 807 "parsing/parser.mly"
       (Longident.t)
-# 46712 "parsing/parser.ml"
+# 46782 "parsing/parser.ml"
     ))
 
 and parse_mod_longident =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1771 lexer lexbuf) : (
-# 803 "parsing/parser.mly"
+# 811 "parsing/parser.mly"
       (Longident.t)
-# 46720 "parsing/parser.ml"
+# 46790 "parsing/parser.ml"
     ))
 
 and parse_mod_ext_longident =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1767 lexer lexbuf) : (
-# 801 "parsing/parser.mly"
+# 809 "parsing/parser.mly"
       (Longident.t)
-# 46728 "parsing/parser.ml"
+# 46798 "parsing/parser.ml"
     ))
 
 and parse_expression =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1763 lexer lexbuf) : (
-# 791 "parsing/parser.mly"
+# 799 "parsing/parser.mly"
       (Parsetree.expression)
-# 46736 "parsing/parser.ml"
+# 46806 "parsing/parser.ml"
     ))
 
 and parse_core_type =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1759 lexer lexbuf) : (
-# 789 "parsing/parser.mly"
+# 797 "parsing/parser.mly"
       (Parsetree.core_type)
-# 46744 "parsing/parser.ml"
+# 46814 "parsing/parser.ml"
     ))
 
 and parse_constr_longident =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1755 lexer lexbuf) : (
-# 795 "parsing/parser.mly"
+# 803 "parsing/parser.mly"
       (Longident.t)
-# 46752 "parsing/parser.ml"
+# 46822 "parsing/parser.ml"
     ))
 
 and parse_any_longident =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1737 lexer lexbuf) : (
-# 805 "parsing/parser.mly"
+# 813 "parsing/parser.mly"
       (Longident.t)
-# 46760 "parsing/parser.ml"
+# 46830 "parsing/parser.ml"
     ))
 
 and interface =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 1733 lexer lexbuf) : (
-# 783 "parsing/parser.mly"
+# 791 "parsing/parser.mly"
       (Parsetree.signature)
-# 46768 "parsing/parser.ml"
+# 46838 "parsing/parser.ml"
     ))
 
 and implementation =
   fun lexer lexbuf ->
     (Obj.magic (MenhirInterpreter.entry 0 lexer lexbuf) : (
-# 781 "parsing/parser.mly"
+# 789 "parsing/parser.mly"
       (Parsetree.structure)
-# 46776 "parsing/parser.ml"
+# 46846 "parsing/parser.ml"
     ))
 
 module Incremental = struct
@@ -46780,115 +46850,115 @@ module Incremental = struct
   let use_file =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1809 initial_position) : (
-# 787 "parsing/parser.mly"
+# 795 "parsing/parser.mly"
       (Parsetree.toplevel_phrase list)
-# 46786 "parsing/parser.ml"
+# 46856 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and toplevel_phrase =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1789 initial_position) : (
-# 785 "parsing/parser.mly"
+# 793 "parsing/parser.mly"
       (Parsetree.toplevel_phrase)
-# 46794 "parsing/parser.ml"
+# 46864 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_val_longident =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1783 initial_position) : (
-# 797 "parsing/parser.mly"
+# 805 "parsing/parser.mly"
       (Longident.t)
-# 46802 "parsing/parser.ml"
+# 46872 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_pattern =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1779 initial_position) : (
-# 793 "parsing/parser.mly"
+# 801 "parsing/parser.mly"
       (Parsetree.pattern)
-# 46810 "parsing/parser.ml"
+# 46880 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_mty_longident =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1775 initial_position) : (
-# 799 "parsing/parser.mly"
+# 807 "parsing/parser.mly"
       (Longident.t)
-# 46818 "parsing/parser.ml"
+# 46888 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_mod_longident =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1771 initial_position) : (
-# 803 "parsing/parser.mly"
+# 811 "parsing/parser.mly"
       (Longident.t)
-# 46826 "parsing/parser.ml"
+# 46896 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_mod_ext_longident =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1767 initial_position) : (
-# 801 "parsing/parser.mly"
+# 809 "parsing/parser.mly"
       (Longident.t)
-# 46834 "parsing/parser.ml"
+# 46904 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_expression =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1763 initial_position) : (
-# 791 "parsing/parser.mly"
+# 799 "parsing/parser.mly"
       (Parsetree.expression)
-# 46842 "parsing/parser.ml"
+# 46912 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_core_type =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1759 initial_position) : (
-# 789 "parsing/parser.mly"
+# 797 "parsing/parser.mly"
       (Parsetree.core_type)
-# 46850 "parsing/parser.ml"
+# 46920 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_constr_longident =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1755 initial_position) : (
-# 795 "parsing/parser.mly"
+# 803 "parsing/parser.mly"
       (Longident.t)
-# 46858 "parsing/parser.ml"
+# 46928 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and parse_any_longident =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1737 initial_position) : (
-# 805 "parsing/parser.mly"
+# 813 "parsing/parser.mly"
       (Longident.t)
-# 46866 "parsing/parser.ml"
+# 46936 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and interface =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 1733 initial_position) : (
-# 783 "parsing/parser.mly"
+# 791 "parsing/parser.mly"
       (Parsetree.signature)
-# 46874 "parsing/parser.ml"
+# 46944 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
   and implementation =
     fun initial_position ->
       (Obj.magic (MenhirInterpreter.start 0 initial_position) : (
-# 781 "parsing/parser.mly"
+# 789 "parsing/parser.mly"
       (Parsetree.structure)
-# 46882 "parsing/parser.ml"
+# 46952 "parsing/parser.ml"
       ) MenhirInterpreter.checkpoint)
   
 end
 
-# 3777 "parsing/parser.mly"
+# 3805 "parsing/parser.mly"
   
 
-# 46890 "parsing/parser.ml"
+# 46960 "parsing/parser.ml"
 
 # 269 "<standard.mly>"
   
 
-# 46895 "parsing/parser.ml"
+# 46965 "parsing/parser.ml"
diff --git a/compilerlibs/Makefile.compilerlibs b/compilerlibs/Makefile.compilerlibs
index 315add7..8a3e923 100644
--- a/compilerlibs/Makefile.compilerlibs
+++ b/compilerlibs/Makefile.compilerlibs
@@ -64,7 +64,8 @@ TYPING=typing/ident.cmo typing/path.cmo \
   typing/typedecl_separability.cmo \
   typing/typedecl.cmo typing/typeopt.cmo \
   typing/rec_check.cmo typing/typecore.cmo typing/typeclass.cmo \
-  typing/typemod.cmo
+  typing/typemod.cmo typing/debug_core.cmo typing/debug_message.cmo \
+  typing/debug_slice.cmo typing/debug_main.cmo
 TYPING_CMI=\
   typing/annot.cmi \
   typing/outcometree.cmi
diff --git a/driver/compile_common.ml b/driver/compile_common.ml
index 95442af..67de963 100644
--- a/driver/compile_common.ml
+++ b/driver/compile_common.ml
@@ -107,14 +107,31 @@ let typecheck_impl i parsetree =
   |> print_if i.ppf_dump Clflags.dump_typedtree
     Printtyped.implementation_with_coercion
 
+(* input structure to be compiled (for type debugger) *)
+let structure = ref []
+
+(* copied from utils/misc.ml (for type debugger) *)
+let my_try_finally ?(exceptionally=(fun _ -> ())) work =
+  match work () with
+    | result -> result
+    | exception work_exn ->
+      let work_bt = Printexc.get_raw_backtrace () in
+      begin
+        exceptionally work_exn;
+        Printexc.raise_with_backtrace work_exn work_bt
+      end
+
 let implementation info ~backend =
   Profile.record_call info.source_file @@ fun () ->
-  let exceptionally () =
+  let exceptionally x =
     let sufs = if info.native then [ cmx; obj ] else [ cmo ] in
     List.iter (fun suf -> remove_file (suf info)) sufs;
+    Debug_main.launch x !structure Compmisc.initial_env; (* for type debugger *)
+    exit 2
   in
-  Misc.try_finally ?always:None ~exceptionally (fun () ->
+  my_try_finally ~exceptionally (fun () ->
     let parsed = parse_impl info in
+    structure := parsed; (* for type debugger *)
     if Clflags.(should_stop_after Compiler_pass.Parsing) then () else begin
       let typed = typecheck_impl info parsed in
       if Clflags.(should_stop_after Compiler_pass.Typing) then () else begin
diff --git a/parsing/parse.ml b/parsing/parse.ml
index b0cee44..d072c3f 100644
--- a/parsing/parse.ml
+++ b/parsing/parse.ml
@@ -134,6 +134,10 @@ let type_ident = wrap_menhir Parser.Incremental.parse_mty_longident
 
 let prepare_error err =
   let open Syntaxerr in
+  let errorf ?(loc = Location.none) en ja = match language with
+      English -> Location.errorf ~loc en
+    | Japanese -> Location.errorf ~loc ja
+  in
   match err with
   | Unclosed(opening_loc, opening, closing_loc, closing) ->
       Location.errorf
@@ -157,6 +161,41 @@ let prepare_error err =
         "In this scoped type, variable %a \
          is reserved for the local type %s."
         Pprintast.tyvar var var
+  (* language levels *)
+  | Expert_exp (str, level, loc) ->
+      begin match str with
+        "if" ->
+          errorf ~loc
+            "L%dError1: did you forget the else part?"
+            "L%dError1: else 部分を忘れていませんか？"
+            level
+      | "for" ->
+          errorf ~loc
+            "L%dError2: for not allowed at this language level"
+            "L%dError2: この言語レベルでは for 文を使うことはできません"
+            level
+      | "while" ->
+          errorf ~loc
+            "L%dError3: while not allowed at this language level"
+            "L%dError3: この言語レベルでは while 文を使うことはできません"
+            level
+      | "sequence" ->
+          errorf ~loc
+            "L%dError4: sequential execution not allowed at this language level"
+            "L%dError4: この言語レベルでは逐次実行文を使うことはできません"
+            level
+      | "assign" ->
+          errorf ~loc
+            "L%dError5: assignments not allowed at this language level"
+            "L%dError5: この言語レベルでは代入文を使うことはできません"
+            level
+      | _ -> Location.error ~loc ("Unsupported Expert_exp error: " ^ str)
+      end
+  | InfixOP0 (str, level, loc) ->
+      errorf ~loc
+        "L%dError6: use %s."
+        "L%dError6: %s を使いましょう"
+        level str
   | Other loc ->
       Location.errorf ~loc "Syntax error"
   | Ill_formed_ast (loc, s) ->
diff --git a/parsing/parser.mly b/parsing/parser.mly
index 1fe25c8..4e7c63d 100644
--- a/parsing/parser.mly
+++ b/parsing/parser.mly
@@ -24,6 +24,8 @@ open Ast_helper
 open Docstrings
 open Docstrings.WithMenhir
 
+let language_level = Syntaxerr.language_level
+
 let mkloc = Location.mkloc
 let mknoloc = Location.mknoloc
 
@@ -578,6 +580,12 @@ let mk_directive ~loc name arg =
       pdir_loc = make_loc loc;
     }
 
+let expert_exp ~loc str =
+  raise Syntaxerr.(Error(Expert_exp(str, language_level, make_loc loc)))
+
+let infixop0 ~loc str =
+  raise Syntaxerr.(Error(InfixOP0(str, language_level, make_loc loc)))
+
 %}
 
 /* Tokens */
@@ -2077,12 +2085,18 @@ class_type_declarations:
 
 seq_expr:
   | expr        %prec below_SEMI  { $1 }
-  | expr SEMI                     { $1 }
+  | expr SEMI                     { if language_level < 3
+                                    then expert_exp ~loc:$loc($2) "sequence"
+                                    else $1 }
   | mkexp(expr SEMI seq_expr
-    { Pexp_sequence($1, $3) })
+    { if language_level < 3
+      then expert_exp ~loc:$loc($2) "sequence" else
+      Pexp_sequence($1, $3) })
     { $1 }
   | expr SEMI PERCENT attr_id seq_expr
-    { let seq = mkexp ~loc:$sloc (Pexp_sequence ($1, $5)) in
+    { if language_level < 3
+      then expert_exp ~loc:$loc($2) "sequence" else
+      let seq = mkexp ~loc:$sloc (Pexp_sequence ($1, $5)) in
       let payload = PStr [mkstrexp seq []] in
       mkexp ~loc:$sloc (Pexp_extension ($4, payload)) }
 ;
@@ -2209,12 +2223,18 @@ expr:
   | IF ext_attributes seq_expr THEN expr ELSE expr
       { Pexp_ifthenelse($3, $5, Some $7), $2 }
   | IF ext_attributes seq_expr THEN expr
-      { Pexp_ifthenelse($3, $5, None), $2 }
+      { if language_level < 3
+        then expert_exp ~loc:$loc "if"
+        else Pexp_ifthenelse($3, $5, None), $2 }
   | WHILE ext_attributes seq_expr DO seq_expr DONE
-      { Pexp_while($3, $5), $2 }
+      { if language_level < 4
+        then expert_exp ~loc:$loc "while"
+        else Pexp_while($3, $5), $2 }
   | FOR ext_attributes pattern EQUAL seq_expr direction_flag seq_expr DO
     seq_expr DONE
-      { Pexp_for($3, $5, $7, $6, $9), $2 }
+      { if language_level < 4
+        then expert_exp ~loc:$loc "for"
+        else Pexp_for($3, $5, $7, $6, $9), $2 }
   | ASSERT ext_attributes simple_expr %prec below_HASH
       { Pexp_assert $3, $2 }
   | LAZY ext_attributes simple_expr %prec below_HASH
@@ -3456,7 +3476,13 @@ operator:
   | infix_operator                              { $1 }
 ;
 %inline infix_operator:
-  | op = INFIXOP0 { op }
+  | op = INFIXOP0 { if language_level < 4
+                    then begin match op with
+                             "==" -> infixop0 ~loc:$loc "="
+                           | "!=" -> infixop0 ~loc:$loc "<>"
+                           | _ -> op
+                         end
+                    else op }
   | op = INFIXOP1 { op }
   | op = INFIXOP2 { op }
   | op = INFIXOP3 { op }
@@ -3475,7 +3501,9 @@ operator:
   | BARBAR        {"||"}
   | AMPERSAND      {"&"}
   | AMPERAMPER    {"&&"}
-  | COLONEQUAL    {":="}
+  | COLONEQUAL    { if language_level < 3
+                    then expert_exp ~loc:$loc "assign"
+                    else ":=" }
 ;
 index_mod:
 | { "" }
diff --git a/parsing/syntaxerr.ml b/parsing/syntaxerr.ml
index 49372b9..5f66ee8 100644
--- a/parsing/syntaxerr.ml
+++ b/parsing/syntaxerr.ml
@@ -13,6 +13,27 @@
 (*                                                                        *)
 (**************************************************************************)
 
+(* language levels *)
+
+type language_t = English | Japanese
+
+let language = try
+  let lang = Sys.getenv "LANG" in
+  if String.sub lang 0 (min 5 (String.length lang)) = "ja_JP"
+  then Japanese
+  else English
+with Not_found -> English
+
+let language_level = try
+  let lang = Sys.getenv "OCAML_LANGUAGE_LEVEL" in
+  match lang with
+    "1" -> 1
+  | "2" -> 2
+  | "3" -> 3
+  | "4" -> 4
+  | _ -> 4
+  with Not_found -> 4
+
 (* Auxiliary type for reporting syntax errors *)
 
 type error =
@@ -21,6 +42,8 @@ type error =
   | Not_expecting of Location.t * string
   | Applicative_path of Location.t
   | Variable_in_scope of Location.t * string
+  | Expert_exp of string * int * Location.t
+  | InfixOP0 of string * int * Location.t
   | Other of Location.t
   | Ill_formed_ast of Location.t * string
   | Invalid_package_type of Location.t * string
@@ -32,6 +55,8 @@ let location_of_error = function
   | Unclosed(l,_,_,_)
   | Applicative_path l
   | Variable_in_scope(l,_)
+  | Expert_exp (_, _, l)
+  | InfixOP0 (_, _, l)
   | Other l
   | Not_expecting (l, _)
   | Ill_formed_ast (l, _)
